unit Unit1;

interface

{Hello, All my modifications end with my initials (adh)}

{I have attached a basic Host/Client Plugin with this to show
you how it's done. Seraj confused a bunch of people by placing
a TForm object in his Host side Dll.}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Alchemw, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

  function PlugType(SlotH : LPSLOT; title: PChar):WORD; export;
  function PlugUnique(SlotH : LPSLOT; args, cMessage: PChar):BOOL; export;
  function PlugProcess(SlotH : LPSLOT):LONGINT; export;
  procedure PlugDestroy(SlotH : LPSLOT); export;
  function PlugDialog(SlotH : LPSLOT; uResult : WORD):WORD; export;
  function PlugButton(SlotH : LPSLOT; id: WORD):WORD; export;
  function PlugData(SlotH : LPSLOT; more: BOOL; data : LPVOID):BOOL; export;
  function PlugMouse(SlotH : LPSLOT; code: BYTE; x, y: WORD):BOOL; export;

implementation

{$R *.DFM}


function PlugDialog(SlotH : LPSLOT; uResult : WORD):WORD;
begin
  PlugDialog := AL_OK;
end;

function PlugData(SlotH : LPSLOT; more: BOOL; data : LPVOID):BOOL;
begin
  PlugData := TRUE;
end;

function PlugUnique(SlotH : LPSLOT; args, cMessage: PChar):BOOL;
begin
  StrPCopy(cMessage, 'Diese Funktion kann nur einmal aufgerufen werden');
  PlugUnique := TRUE;
end;

procedure PlugDestroy(SlotH : LPSLOT);
begin
end;

function PlugButton(SlotH : LPSLOT; id: WORD):WORD;
begin
  PlugButton := AL_IDLE;
end;

function PlugMouse(SlotH : LPSLOT; code: BYTE; x, y: WORD):BOOL;
begin
  PlugMouse := BOOL(AL_IDLE);
end;

function PlugType(SlotH : LPSLOT; title: PChar):WORD;
begin
  {This form will only show on the Camelot Side... your users
   will NEVER see it as there is no Client plug evident. Also,
   the global variable for Form1 will be corrupted if you try
   a multi user plug. It'll crash your system. The Camelot side
   of a plug-in really should be completely non-visual and use
   only Local Variables and Constants} {(Adh)}

  StrPCopy(title, 'NC-CONNECTION');
  if not assigned(Form1) then
  begin
    Application.CreateForm( TForm1, Form1);
    Form1.Show;
  end;
  PlugType := AL_WIN_PLUGIN;
end;

function PlugProcess(SlotH : LPSLOT):LONGINT;
begin
  PlugProcess := AL_IDLE;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;



{Notes: This plugin is structured for a AL_WIN_GRAPHIC or AL_WIN_MULTI
        but the presence of the TForm object and AL_WIN_PLUGIN tells
        me you are trying for a Host/Client Plugin. Therefore, you will
        need another DLL for the Client end with the appropriate shells
        eg: PlugInit, PlugProcess ect for the client side and entry
        points in a PlugCommand on this end.}

end.

